package eShopper;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * IngredientWindow serves as an abstract class from which are created the
 * CreateIngredientWindow and ManageIngredientWindow classes.
 * 
 * @author Nathan
 */
abstract public class IngredientWindow extends eShopperGUI {

	JPanel mainPanel = new JPanel();
	JPanel namePanel = new JPanel();
	JPanel descriptionPanel = new JPanel();
	JScrollPane descScrollPane;
	JPanel buttonPanel = new JPanel();
	JTextArea descArea;
	
	IngredientWindow(eShopperList list){
		this.list = list;
		this.database = list.getDB();
		
		setSize(305, 200);
		setResizable(false);
		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
		mainPanel.setBorder(BorderFactory.createEmptyBorder(12,12,11,11));
		
		//
		// name panel
		//
		
		namePanel.setVisible(true);
		namePanel.setAlignmentX(Component.CENTER_ALIGNMENT);
		namePanel.setLayout ( new BoxLayout(namePanel, BoxLayout.X_AXIS) );
		
		//
		// description panel
		//
		
		descriptionPanel.setMinimumSize( new Dimension(320, 70) );
		descriptionPanel.setMaximumSize( new Dimension(320, 70) );
		descriptionPanel.setPreferredSize( new Dimension(320, 70) );
		descriptionPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
		descriptionPanel.setLayout(new BoxLayout(descriptionPanel, BoxLayout.Y_AXIS));
		
		descriptionPanel.add(new JLabel("Description:"));
		descArea = new JTextArea(3, 20);
		descArea.setWrapStyleWord(true);
		descArea.setLineWrap(true);
		descScrollPane = new JScrollPane(descArea);
		descScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		descScrollPane.setPreferredSize(new Dimension(200, 50));
		descriptionPanel.add(descScrollPane);
		
		//
		// buttonPanel
		//
		
		buttonPanel.setMinimumSize( new Dimension(320, 25) );
		buttonPanel.setMaximumSize( new Dimension(320, 25) );
		buttonPanel.setPreferredSize( new Dimension(320, 25) );
		buttonPanel.setAlignmentX(Component.CENTER_ALIGNMENT);
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.add(Box.createHorizontalGlue());
		JButton aButton = new JButton("Save");
		aButton.addActionListener(this);
		aButton.setActionCommand("Save");
		aButton.setMnemonic(KeyEvent.VK_S);
		buttonPanel.add(aButton);
		buttonPanel.add( Box.createRigidArea(new Dimension(6,0)) );
		aButton = new JButton("Close");
		aButton.addActionListener(this);
		aButton.setActionCommand("close");
		buttonPanel.add(aButton);
	}
	
	abstract public void updateDatabase();
	
	/**
	 * This handles all of the ActionEvents generated by buttons on the window.
	 */
	public void actionPerformed(ActionEvent e){
		if (e.getActionCommand().equals("Save"))
			updateDatabase();
		else if (e.getActionCommand().equals("close"))
			dispose();
	}
}
