/*
 * Created on May 10, 2004
 *
 * A quick class to support the "Unsorted" type category on our list
 *
 */
package eShopper;

import java.util.Vector;

/**
 * This is a miscelaneous item in the list.  It is actually just
 * the grouping for the Recipes and Ingredients not associated with a date.
 * 
 * @author Jim Laing
 *
 */
public class eShopperMisc extends eShopperNode {
	
	private Vector children;

	public eShopperMisc(Vector children) {
		this.children = children;
	}
	
	/**
	 * This returns the children of the Other heading.
	 * 
	 * @return A vector of the recipes and ingredients in the list not
	 * associated with a date.
	 */
	public Vector getChildren() { return children; }

	/**
	 * This returns the name of the node.
	 * 
	 * @return Always returns the string "Other".
	 */
	public String toString() { return "Other"; }

	/**
	 * This always returns null, because this node cannot have a date.
	 * 
	 * @return Always returns null.
	 */
	public String getDate() { return null; 	}

	/**
	 * This returns the nodeID 0, which means it's not a Recipe or Ingredient.
	 * 
	 * @return Always returns 0.
	 */
	public int nodeID() { return 0; }

}
